;-----------------------------------------------------
;Gestione ciclo funzionamento normale
;Fa parte del mainloop ed  eseguito ogni ms circa (ritardo deli_1ms)

;Effettua le seguenti operazioni:
; 1) Genera un numero casuale per l'effetto tremolo e l'accensione casuale
; 2) Pilota la luminosit di ogni uscita con o senza effetto tremolo
; 3) Verifica se  trascorso il tempo del singolo passo (512 passi per ogni
;    fase, da 20ms a 85s circa). Ritorna al mainloop in caso negativo
; 4) F lampeggiare il led Time in funzione del tempo fase selezionato
; 5) Gestisce l'inizio di ciascuna delle 4 fasi (prelevamento dati utente
;    dalla memoria Eeprom)
; 6) Genera il valore di luminosit corrente secondo l'effetto selezionato

run_cycle
        call    deli_1ms                ;Ritardo 1ms con irq attivi

        call    make_fixspeed_random    ;Genera velocit fisse e un numero casuale
                                        ;con tempistica variabile da 10 a 100ms

        call    flicker_drive_output    ;Genera effetto tremolio sulle uscite
                                        ;(se desiderato) e pilota la luminosit
                                        ;delle 10 uscite

;per prova inizio
;        movlw  0xFF                    ;Al posto di flicker_drive_output
;        movwf  RandomH
;        movwf  RandomL

;        movf   LtValue+0x00,w
;        movwf  Light+0x00
;        movf   LtValue+0x01,w
;        movwf  Light+0x01
;        movf   LtValue+0x02,w
;        movwf  Light+0x02
;        movf   LtValue+0x03,w
;        movwf  Light+0x03
;        movf   LtValue+0x04,w
;        movwf  Light+0x04
;        movf   LtValue+0x05,w
;        movwf  Light+0x05
;        movf   LtValue+0x06,w
;        movwf  Light+0x06
;        movf   LtValue+0x07,w
;        movwf  Light+0x07
;        movf   LtValue+0x08,w
;        movwf  Light+0x08
;        movf   LtValue+0x09,w
;        movwf  Light+0x09

;        clrw                            ;Accende Out5 su Fase Parte2
;        btfsc  F_LDEFFP2                ;Sostituire D'5' nei loop delle sub
;        movlw  0xFF                     ;flicker_drive_output e make_light_value
;        movwf  Light+0x05               ;per escludere dagli effetti Out6..Out10

;        clrf   Light+0x06               ;Out6 spenta

;        clrw                            ;Visualizza su Out8,9,10 la fase corrente
;        btfsc  CStepH,3
;        movlw  0xFF
;        movwf  Light+0x07
;        clrw
;        btfsc  CStepH,2
;        movlw  0xFF
;        movwf  Light+0x08
;        clrw
;        btfsc  CStepH,1
;        movlw  0xFF
;        movwf  Light+0x09
;fine per prova

        btfss   I_PMENU                 ;Continua se pulsante PMenu non  premuto
        goto    main_loop
        btfss   F_TSTEP                 ;Continua se  trascorso il tempo impostato
        goto    main_loop               ;del singolo passo (T10msH,L = C10msH,L)
                                        ;C10msH,L  incrementata ogni 10ms da rb0_int

                                        ;*** Eseguito ad ogni passo (da 20ms ... a 84.3s)
        clrf    C10msH                  ;Azzera contatore 10ms
        clrf    C10msL                  ;e azzera flag raggiungimento tempo singolo passo
        bcf     F_TSTEP
        call    toggle_led_time         ;F lampeggiare il led Time

                                        ;Gestisce l'inizio di ciascuna fase
        movf    CStepL,f                ;Se CStepH,L multiplo di 512
        btfss   STATUS,Z                ;(0, 512, 1024, 1536, 2048, 2560, 3072, 3548)
        goto    rc_2                    ;preleva le impostazioni utente da EEprom
        btfsc   CStepH,0                ;relative agli effetti e alle modalit effetti
        goto    rc_1
        call    start_fase_p1           ;Se CStepH,L multiplo di 512 a partire da 256
        goto    rc_2                    ;(256, 768, 1280, 1792, 2304, 2816, 3328, 3840)
rc_1    call    start_fase_p2           ;preleva solo le impostazioni effetti da EEprom

rc_2
        call    make_lights_value       ;Genera i 10 valori assoluti di luminosit
                                        ;su LtValue(x) secondo l'andamento impostato
                                        ;in LtEffM(x) e gestisce stato random on-off

        incfsz  CStepL,f                ;Incrementa contatore passi.
        goto    main_loop               ;Azzera se giunto al massimo (4096)
        incf    CStepH,f                ;ogni fase 512 passi
        btfss   CStepH,4                ;8 fasi --> Totale: 4096 passi
        goto    main_loop               ;Inizializza luminosit di partenza per
        clrf    CStepH                  ;gli effetti dissolvenza
        clrf    CStepL
        bcf     F_LTINIT
        goto    main_loop               ;Ritorna al main


;-----------------------------------------------------
;Genera velocit fisse ed un numero casuale utilizzato per:
; - far tremolare il livello di luminost sulle uscite
; - gestire l'accensione casuale delle uscite
;Per aumentare la casualit, la modifica del valore casuale si effettua
;ad intervalli crescenti, da un minimo di 10ms ad un massimo di 100ms circa.
;Questa sub  richiamata ogni 1ms circa nel mainloop

; Input:  SpdFixL, SpdFixH, RandomH, RandomL, DelRnd, CntRnd
; Output: SpdFixL, SpdFixH, RandomH, RandomL, DelRnd, CntRnd

make_fixspeed_random
        incf    SpdFixL,f       ;Incrementa le variabili per generare velocit fisse
        btfss   SpdFixL,4       ;prelevate dai vari bit di SpdFixH
        goto    mfr_0
        clrf    SpdFixL
        incf    SpdFixH,f

mfr_0   decfsz  CntRnd,f        ;Decrementa contatore per ritardo variabile casuale
        return                  ;Esce se <>0
        movf    DelRnd,w        ;Se il ritardo  al massimo
        xorlw   D'100'          ;lo imposta al minimo
        btfss   STATUS,Z
        goto    mfr_1
        movlw   D'10'
        movwf   DelRnd
        goto    mfr_2
mfr_1   incf    DelRnd,f        ;Incrementa la variabile per il ritardo
mfr_2   movf    DelRnd,w        ;Copia il valore nel contatore CntRnd
        movwf   CntRnd

        btfss   RandomH,6       ;Generazione numeri casuali in RandomH,L ottenuta
        goto    mfr_3           ;ruotandola a sinistra e facendo entrare in
        btfsc   RandomH,4       ;carry 1 o 0 secondo la xor dei bit 6 e 4
        goto    mfr_4
        goto    mfr_5           ;       Random,6  Random,4   XOR
mfr_3   btfsc   RandomH,4       ;          0         0        1
        goto    mfr_5           ;          0         1        0
                                ;          1         0        0
mfr_4   bsf     STATUS,C        ;          1         1        1
	goto    mfr_6
mfr_5   bcf     STATUS,C
mfr_6   rlf     RandomL,f       ;Ruota a sx RandomL e fa entrare il nuovo bit Carry
        rlf     RandomH,f       ;Ruota a sx RandomH e fa entrare il bit di RandomL
        return


;-----------------------------------------------------
;Genera l'effetto tremolante stabilito da utente e pilota la luminosit delle uscite.
;Sono disponibili:
; - 4 tremoli con velocit casuale, dove  possibile scegliere 4 riduzioni di
;   luminosit del 50%, 25%, 12% e 6%
; - 3 tremoli a velocit fissa, dove la riduzione di luminosit  fissa sul 25%
;L'effetto tremolo, generato solo sulle uscite abilitate da utente,
;viene effettuato riducendo la luminosit (variabili Light(x))
;rispetto al corrispondente valore assoluto (variabili LtValue(x)).
;Se uscita non abilitata, imposta a zero il valore di luminosit Light(x)

; Input:  LtEffM(0..9)
; Input:  LtValue(0..9)
; Input:  RandomH, RandomL, SpdFixH
; Output: Light(0..9)
; Usate:  Count1, Count2, Value, Temp

flicker_drive_output
        clrf    Count1          ;Azzera contatore 10 uscite (0..9)
        movf    RandomH,w       ;Copia il primo valore casuale su Temp
        movwf   Temp

fdo_1   movlw   LtEffM+0x00     ;Carica su Count2 l'impostazione Modalit Effetti corrente
        addwf   Count1,w        ;Count2 = LtEffM(x)
        movwf   FSR
        movf    INDF,w
        movwf   Count2

        movlw   LtValue+0x00    ;Punta alla locazione LtValue(x) corrente
        addwf   Count1,w        ;relativa al valore assoluto di luminosit
        movwf   FSR

        btfsc   Count2,ENABLE   ;Se uscita disabilitata pone Value=0
        goto    fdo_2
        clrf    Value
        goto    fdo_11

fdo_2   movf    Count2,w        ;Estrae i bit2,1,0 relativi alla modalit tremolo
        andlw   B'00000111'
        movwf   Count2
        btfsc   STATUS,Z
        goto    fdo_off         ;Se tremolo non abilitato, salta

        movlw   0x05            ;Verifica se velocit flicker variabile (Count2<5)
        subwf   Count2,w        ;o fissa (Count>=5)
        btfss   STATUS,C
        goto    fdo_5
        movf    Count2,w        ;Tremolo con Velocit fissa minima e riduzione 25%
        xorlw   0x05
        btfss   STATUS,Z
        goto    fdo_3
        btfss   SpdFixH,5
        goto    fdo_off
        goto    fdo_on

fdo_3   movf    Count2,w        ;Tremolo con Velocit fissa media e riduzione 25%
        xorlw   0x06
        btfss   STATUS,Z
        goto    fdo_4
        btfss   SpdFixH,4
        goto    fdo_off
        goto    fdo_on

fdo_4   btfss   SpdFixH,3       ;Tremolo con Velocit fissa massima e riduzione 25%
        goto    fdo_off
        goto    fdo_on

fdo_5   btfsc   Temp,7          ;Tremolo con velocit variabile
        goto    fdo_off
        goto    fdo_6

fdo_on  movlw   0x03            ;Se velocit fissa imposta riduzione luminosit al 25%
        movwf   Count2

fdo_6   movlw   D'200'          ;Se valore luminoit <200, riduce ulteriormente
        subwf   INDF,w          ;luminosit tremolo per rendere uniforme l'effetto
        btfsc   STATUS,C        ;tremolo al variare della luminosit
        goto    fdo_7
        decf    Count2,f
        goto    fdo_8
fdo_7   movlw   D'240'          ;Se valore luminosit >240, e tremolo velocit
        subwf   INDF,w          ;variabile tipo 1-2, sottrae il valore fisso 50
        btfss   STATUS,C
        goto    fdo_8
        movf    Count2,w
        sublw   0x02
        btfss   STATUS,C
        goto    fdo_8
        movlw   D'50'
        goto    fdo_10

fdo_8   movf    INDF,w          ;Calcola la quantit di luce da sottrarre al valore
        movwf   Value           ;assoluto di luminosit LtValue(x)
fdo_9   bcf     STATUS,C
        rrf     Value,f
        incf    Count2,f
        movf    Count2,w
        xorlw   0x05
        btfss   STATUS,Z
        goto    fdo_9
        movf    Value,w         ;Calcola differenza Value = LtValue(x) - Value
fdo_10  subwf   INDF,w
        movwf   Value
        goto    fdo_11

fdo_off movf    INDF,w          ;Tremolo non attivo. Pone Value = LtValue(x)
        movwf   Value

fdo_11  movlw   Light+0x00      ;Pone Light(x) = Value
        addwf   Count1,w
        movwf   FSR
        movf    Value,w
        movwf   INDF

        rlf     Temp,f          ;Ruota valore casuale per prelevare prossimo
        movf    Count1,w        ;valore Tremolo per prossima uscita
        xorlw   0x04
        btfss   STATUS,Z        ;Se Count1=4 (met ciclo) preleva il secondo
        goto    fdo_12          ;valore casuale per uscite 6..10
        movf    RandomL,w
        movwf   Temp

fdo_12  incf    Count1,f        ;Incrementa e verifica contatore (0..9)
        movf    Count1,w
        xorlw   D'10'           ;D'5' per test 5 uscite, D'10' normalmente
        btfss   STATUS,Z
        goto    fdo_1           ;Salta per prossima variabile
        return


;-----------------------------------------------------
;Gestisce l'inizio di ciascuna 'fase temporale' (una porzione di 1/8 dell'intero ciclo)
;Ciascuna fase  suddivisa in Parte1 (carica tutto) e Parte2 (carica solo effetti)

; - Preleva impostazione tempo da EEprom e, attraverso la tabella rom, carica
;   in T10msH,L il valore per ottenere il 'tempo fase' desiderato.
;   Se tempo=0 salta alla fase temporale successiva.
; - Preleva impostazioni Andamento+Stati delle 10 uscite e li carica in LtEffM (0..9)
;   Se abilitata funzione 'random on-off' genera, dai valori numerici casuali,
;   l'abilitazione al funzionamento di ciascuna uscita (relativa alla fase corrente)
; - All'inizio del ciclo inizializza i valori di luminosit per gli effetti dissolvenza

; Input:  CStepH, CStepL                Contatore passi del ciclo
; Input:  RandomH, RandomL              Valori casuali
; Output: T10msH, T10msL                Tempo del singolo passo
; Output: LtEffM(x)                     Andamento + Stati luminosit
; Usate:  Flags
; Usate:  Temp, Value, Count1, Count2   Appoggi vari

start_fase_p2                           ;Se richiamata Parte2 salta per il caricamento
        bsf     F_LDEFFP2               ;solo degli effetti
        goto    sf_2

start_fase_p1                           ;Se richiamata Parte1 carica tutto
        bcf     F_LDEFFP2
                                        ;1) ****
        rrf     CStepH,w                ;Preleva settaggio tempo (0..63) da locazione
        andlw   B'00000111'             ;Eeprom 0..7 secondo la fase corrente, indicata
        call    read_eeprom             ;dai bit 3,2,1 di CStepH
        andlw   B'00111111'
        movwf   Temp
        movf    Temp,w                  ;Se Tempo=0 incrementa CStepH per saltare
        btfss   STATUS,Z                ;alla prossima fase temporale
        goto    sf_1
        movlw   0x02
        addwf   CStepH,f
        btfss   CStepH,4                ;Verifica se giunti all'ultima fase temporale
        goto    start_fase_p1           ;per re-inizializzare il ciclo
        clrf    CStepH
        clrf    CStepL
        bcf     F_LTINIT
        goto    start_fase_p1

sf_1    decf    Temp,f                  ;Se tempo fase impostato <>0
        rlf     Temp,f                  ;preleva valore T10msH,L dalla tabella rom
        bcf     Temp,0                  ;secondo l'offset dell'impostazione letta
        movlw   0x07                    ;dalla memoria eeprom
        movwf   PCLATH
        movf    Temp,w
        call    TBL_TIMESTEP            ;Preleva byte H
        movwf   T10msH
        movlw   0x07
        movwf   PCLATH
        incf    Temp,w
        call    TBL_TIMESTEP            ;Preleva byte L
        movwf   T10msL

                                        ;2) ****
sf_2    movlw   LtEffM+0x00             ;Preleva gli Effetti Parte1 o Parte2
        movwf   FSR                     ;relativi alle 10 uscite
        clrf    Count1
sf_3    rrf     CStepH,w                ;Calcola l'indirizzo di prelievo della Eeprom
        andlw   B'00000111'             ;8..87 secondo la formula:
        addlw   D'8'                    ;Address= 8 + Fase + Out * 8
        movwf   Temp                    ;dove 8=Offset, Fase=0..7 e Out=0..9
        movf    Count1,w
        movwf   Count2
sf_4    btfsc   STATUS,Z
        goto    sf_5
        movf    Temp,w
        addlw   0x08
        movwf   Temp
        decf    Count2,f
        goto    sf_4
sf_5    movf    Temp,w
        call    read_eeprom             ;Preleva da EEprom l'effetto
        movwf   Value                   ;Se Parte1 preleva i 4 bit MSB
        btfsc   F_LDEFFP2               ;Se Parte2 preleva i 4 bit LSB
        swapf   Value,f                 ;Copia l'effetto nei bit 7,6,5,4 di LtEffM(0..9)
        movf    Value,w
        andlw   B'11110000'
        movwf   INDF
        incf    FSR,f                   ;Incremeta puntatore LtEffM
        incf    Count1,f                ;Incrementa contatore uscita da 0 a 9
        movf    Count1,w
        xorlw   D'10'
        btfss   STATUS,Z
        goto    sf_3

;per prova
;        goto    sf_test

                                        ;3) ****
        movlw   LtEffM+0x00             ;Preleva la Modalit Effetti (Random+Tremolo)
        movwf   FSR                     ;dell'intera fase relativi alle 10 uscite
        clrf    Count1
sf_6    movf    CStepH,w
        movwf   Temp                    ;Calcola l'indirizzo di prelievo della Eeprom
        rrf     Temp,f                  ;88..127 secondo la formula:
        rrf     Temp,w                  ;Address= 88 + Fase/2 + Out * 4
        andlw   B'00000011'             ;dove Fase=0..7 e Out=0..9
        addlw   D'88'
        movwf   Temp
        movf    Count1,w
        movwf   Count2
sf_7    btfsc   STATUS,Z
        goto    sf_8
        movf    Temp,w
        addlw   0x04
        movwf   Temp
        decf    Count2,f
        goto    sf_7
sf_8    movf    Temp,w
        call    read_eeprom             ;Preleva da EEprom la modalit effetto
        movwf   Value
        movf    Value,w                 ;Se Fase pari (0,2,4,6) preleva i 4 bit MSB
        btfss   CStepH,1                ;Se Fase dispari (1,3,5,7) preleva i 4 bit LSB
        swapf   Value,w                 ;Copia l'effetto nei bit 3,2,1,0 di LtEffM(0..9)
        andlw   B'00001111'
        movwf   Value
        movf    INDF,w
        iorwf   Value,w
        movwf   INDF
        incf    FSR,f                   ;Incremeta puntatore LtEffM
        incf    Count1,f                ;Incrementa contatore uscita da 0 a 9
        movf    Count1,w
        xorlw   D'10'
        btfss   STATUS,Z
        goto    sf_6

                                        ;4) ****
        movf    RandomH,w               ;Trasforma il bit RND_EN (on-off random) di
        movwf   Value                   ;LtEffM(0..9) secondo l'impostazione random on-off
        movlw   LtEffM+0x00             ;Value,0 contiene un bit casuale
        movwf   FSR
        clrf    Count1
sf_9    btfss   INDF,RND_EN             ;RND_EN   Value_Random   ENABLE_LIGHT
        goto    sf_10                   ;   0          x               1        sempre on
        btfss   Value,0                 ;   1          0               0        off random
        goto    sf_11                   ;   1          1               1        on random
sf_10   bsf     INDF,ENABLE
        goto    sf_12
sf_11   bcf     INDF,ENABLE
sf_12   movf    Count1,w                ;Quando Count=4 (met ciclo) preleva il secondo
        xorlw   0x04                    ;valore casuale per generare on-off random
        btfss   STATUS,Z                ;sulle uscite 5..10
        goto    sf_13
        movf    RandomL,w
        movwf   Value
        goto    sf_14
sf_13   rrf     Value,f                 ;Ruota il valore casuale per prelevare
sf_14   incf    FSR,f                   ;il bit relativo all'uscita successiva
        incf    Count1,f
        movf    Count1,w                ;Incrementa contatore uscita da 0 a 9
        xorlw   D'10'
        btfss   STATUS,Z
        goto    sf_9

;per prova
;sf_test
        btfsc   F_LDEFFP2               ;Esce se effettuato caricamento solo di Parte2
        return

                                        ;5) ****
        btfsc   F_LTINIT                ;All'inizio del ciclo (prima fase temporale abilitata)
        return                          ;inizializza i valori di luminosit in LtValue(0..9)
        bsf     F_LTINIT                ;a 0 (crescente) o a 255 (decrescente) secondo
        clrf    Count1                  ;l'effetto dissolveza impostato da utente
sf_15   movlw   LtEffM+0x00
        addwf   Count1,w
        movwf   FSR                     ;Individua variabile LtEffM(0..9)
        btfss   INDF,7                  ;Verifica se effetto dissolvenza
        goto    sf_16
        clrf    Value                   ;Pone Value=0 se effetto dissolvenza crescente
        btfsc   INDF,6
        decf    Value,f                 ;Pone Value=255 se effetto dissolvenza decrescente
        movlw   LtValue+0x00
        addwf   Count1,w
        movwf   FSR                     ;Copia valore luminosit su LtValue(0..9)
        movf    Value,w
        movwf   INDF
sf_16   incf    Count1,f                ;Incrementa contatore uscita da 0 a 9
        movf    Count1,w
        xorlw   D'10'
        btfss   STATUS,Z
        goto    sf_15
        return


;-----------------------------------------------------
;Genera il valore di luminosit assoluta (senza effetto tremolo) delle 10 uscite,
;sulle variabili LtValue(x), secondo l'andamento impostato in LtEffM(x).
;La sub flicker_drive_output (richiamata nel mainloop) provveder a
;modificare realmente la luminosit delle uscite, copiando i valori assoluti
;LtValue(x) su Light(x) e a gestire le uscite non abilitate

;Input:  LtEffM(0..9)
;Input:  CStepH, CStepL
;Output: LtValue(0..9)
;Usate:  Count1, Value, Temp

make_lights_value
        clrf    Count1                  ;Azzera contatore

mlv_1   movlw   LtEffM+0x00             ;Calcola indirizzo per LtEffM(0..9)
        addwf   Count1,w                ;ed estrae l'effetto impostato
        movwf   FSR
        movf    INDF,w
        andlw   B'11110000'
        movwf   Value
        swapf   Value,f

        movlw   LtValue+0x00            ;Precarica l'indirizzo di LtValue(x)
        addwf   Count1,w
        movwf   FSR

        clrf    Temp
        movlw   D'85'                   ;Se CStepL>=85 setta Temp,0 per comodit
        subwf   CStepL,w                ;impostazione effetti on-off
        btfsc   STATUS,C
        bsf     Temp,0
        movlw   D'170'                  ;Se CStepL>=170 setta Temp,1 per comodit
        subwf   CStepL,w                ;impostazione effetti on-off
        btfsc   STATUS,C
        bsf     Temp,1

                                        ;*** Effetti ON-OFF
        movf    Value,w                 ;0: off-off-off
        btfsc   STATUS,Z
        goto    mlv_off

        xorlw   D'1'                    ;1: off-off-on
        btfss   STATUS,Z
        goto    mlv_2
        btfss   Temp,1
        goto    mlv_off
        goto    mlv_on

mlv_2   movf    Value,w                 ;2: off-on-off
        xorlw   D'2'
        btfss   STATUS,Z
        goto    mlv_3
        btfss   Temp,0
        goto    mlv_off
        btfss   Temp,1
        goto    mlv_on
        goto    mlv_off

mlv_3   movf    Value,w                 ;3: off-on-on
        xorlw   D'3'
        btfss   STATUS,Z
        goto    mlv_4
        btfss   Temp,0
        goto    mlv_off
        goto    mlv_on

mlv_4   movf    Value,w                 ;4: on-off-off
        xorlw   D'4'
        btfss   STATUS,Z
        goto    mlv_5
        btfss   Temp,0
        goto    mlv_on
        goto    mlv_off

mlv_5   movf    Value,w                 ;5: on-off-on
        xorlw   D'5'
        btfss   STATUS,Z
        goto    mlv_6
        btfss   Temp,0
        goto    mlv_on
        btfss   Temp,1
        goto    mlv_off
        goto    mlv_on

mlv_6   movf    Value,w                 ;6: on-on-off
        xorlw   D'6'
        btfss   STATUS,Z
        goto    mlv_7
        btfss   Temp,1
        goto    mlv_on
        goto    mlv_off

mlv_7   movf    Value,w                 ;7: on-on-on
        xorlw   D'7'
        btfss   STATUS,Z
        goto    mlv_8
        goto    mlv_on

                                        ;*** Effetti DISSOLVENZA
mlv_8   movf    CStepL,w                ;Estrae su Temp i tre bit LSB di CStepL
        andlw   B'00000111'             ;per comodit
        movwf   Temp

        movf    Value,w                 ;8: Rampa crescente 6%
        xorlw   D'8'                    ;un incremento ogni 8 passi
        btfss   STATUS,Z
        goto    mlv_9
        movf    Temp,w
        xorlw   B'00000111'
        btfss   STATUS,Z
        goto    mlv_e
        goto    mlv_inc

mlv_9   movf    Value,w                 ;9: Rampa crescente 12%
        xorlw   D'9'                    ;un incremento ogni 4 passi
        btfss   STATUS,Z
        goto    mlv_10
        movf    Temp,w
        andlw   B'00000011'
        xorlw   B'00000011'
        btfss   STATUS,Z
        goto    mlv_e
        goto    mlv_inc

mlv_10  movf    Value,w                 ;10: Rampa crescente 25%
        xorlw   D'10'                   ;un incremento ogni 2 passi
        btfss   STATUS,Z
        goto    mlv_11
        btfss   Temp,0
        goto    mlv_e
        goto    mlv_inc

mlv_11  movf    Value,w                 ;11: Rampa crescente 50%
        xorlw   D'11'                   ;un incremento ogni passo
        btfss   STATUS,Z
        goto    mlv_12
        goto    mlv_inc

mlv_12  movf    Value,w                 ;12: Rampa decrescente 6%
        xorlw   D'12'                   ;un decremento ogni 8 passi
        btfss   STATUS,Z
        goto    mlv_13
        movf    Temp,w
        xorlw   B'00000111'
        btfss   STATUS,Z
        goto    mlv_e
        goto    mlv_dec

mlv_13  movf    Value,w                 ;13: Rampa decrescente 12%
        xorlw   D'13'                   ;un decremento ogni 4 passi
        btfss   STATUS,Z
        goto    mlv_14
        movf    Temp,w
        andlw   B'00000011'
        xorlw   B'00000011'
        btfss   STATUS,Z
        goto    mlv_e
        goto    mlv_dec

mlv_14  movf    Value,w                 ;14: Rampa decrescente 25%
        xorlw   D'14'                   ;un decremento ogni 2 passi
        btfss   STATUS,Z
        goto    mlv_15
        btfss   Temp,0
        goto    mlv_e
        goto    mlv_dec

mlv_15  goto    mlv_dec                 ;15: Rampa decrescente 50%
                                        ;un decremento ogni passo

                                        ;*** Modifica variabili
mlv_off clrf    INDF                    ;Luminosit OFF (LtValue(x)=0)
        goto    mlv_e

mlv_on  movlw   D'255'                  ;Luminosit ON (LtValue(x)=255)
        movwf   INDF
        goto    mlv_e

mlv_inc movf    INDF,w                  ;Incrementa LtValue(x) se diversa da 255
        xorlw   D'255'
        btfss   STATUS,Z
        incf    INDF,f
        goto    mlv_e

mlv_dec movf    INDF,w                  ;Decrementa LtValue(x) se diversa da 0
        btfss   STATUS,Z
        decf    INDF,f

mlv_e   incf    Count1,f                ;Incrementa contatore per prossima variabile
        movf    Count1,w                ;LtEffM(x) e quindi Light(x)
        xorlw   D'10'                   ;D'5' per test 5 uscite, D'10' normalmente
        btfss   STATUS,Z                ;Esce se completate le 10 variabili
        goto    mlv_1
        return
