;-----------------------------------------------------
;Gestione Men principale

;Accende i led associati alle uscite OUT1...OUT9 per indicare
;all'utente la possibilit di accedere ad uno dei 9 men premendo
;il pulsante PMENU
;Richiama i men 1..8 (impostazione tempi) o il men 9 (test uscite)
;se l'utente preme il pulsante durante il tempo in cui  acceso il
;led corrispondente. Alla fine ritorna al ciclo di funzionamento normale
; Output: O_LTIME, O_OUT1...9
; Output: Menu
; Input:  I_PMENU
; Usate:  CPMenuL

choose_menu
        call    out_irq_off     ;Disattiva irq e spegne tutte le uscite
        call    del_1s
        movlw   0x01            ;Men 1
        movwf   Menu
cmu_1   call    out_irq_off
        bsf     O_LTIME         ;Led Time on: segnalazione men principale

        movf    Menu,w          ;Accende i led relativi alle uscite 1..9 
        xorlw   0x01            ;per indicare uno dei 9 menu da scegliere
        btfss   STATUS,Z        ;Indica Menu1
        goto    cmu_2
        bsf     O_OUT1
        goto    cmu_10
cmu_2   movf    Menu,w          ;Indica Menu2
        xorlw   0x02
        btfss   STATUS,Z
        goto    cmu_3
        bsf     O_OUT2
        goto    cmu_10
cmu_3   movf    Menu,w          ;Indica Menu3
        xorlw   0x03
        btfss   STATUS,Z
        goto    cmu_4
        bsf     O_OUT3
        goto    cmu_10
cmu_4   movf    Menu,w          ;Indica Menu4
        xorlw   0x04
        btfss   STATUS,Z
        goto    cmu_5
        bsf     O_OUT4
        goto    cmu_10
cmu_5   movf    Menu,w          ;Indica Menu5
        xorlw   0x05
        btfss   STATUS,Z
        goto    cmu_6
        bsf     O_OUT5
        goto    cmu_10
cmu_6   movf    Menu,w          ;Indica Menu6
        xorlw   0x06
        btfss   STATUS,Z
        goto    cmu_7
        bsf     O_OUT6
        goto    cmu_10
cmu_7   movf    Menu,w          ;Indica Menu7
        xorlw   0x07
        btfss   STATUS,Z
        goto    cmu_8
        bsf     O_OUT7
        goto    cmu_10
cmu_8   movf    Menu,w          ;Indica Menu8
        xorlw   0x08
        btfss   STATUS,Z
        goto    cmu_9
        bsf     O_OUT8
        goto    cmu_10
cmu_9   bsf     O_OUT9          ;Indica Menu9

cmu_10  movlw   D'20'           ;Attende che l'utente preme il pulsante entro 2
        movwf   CPMenuL         ;secondi per accedere al menu corrente
cmu_11  call    del_100ms
        btfss   I_PMENU
        goto    cmu_12
        decfsz  CPMenuL,f
        goto    cmu_11
        goto    cmu_15          ;Se trascorsi 2s, incrementa per prossimo menu

cmu_12  call    out_irq_off     ;Entra in uno dei 9 menu selezionati
        call    led_begin_menu
        movf    Menu,w
        xorlw   0x09
        btfss   STATUS,Z
        goto    cmu_13
        call    menu9           ;Richiama il menu 9 per Test Uscite
        goto    cmu_14
cmu_13  call    menu1__8        ;Richiama i menu 1..8 per settaggio tempi
cmu_14  call    out_irq_off
        call    led_end_menu

cmu_15  incf    Menu,f          ;Incrementa per prossimo menu
        movf    Menu,w
        xorlw   D'10'
        btfss   STATUS,Z        ;Giunto al massimo?
        goto    cmu_1           ;No, ripete per prossimo menu
        call    out_irq_off     ;Si, esce e riavvia il programma
        call    del_1s
        goto    main_start


;-----------------------------------------------------
;Gestione Menu 0 (Caricamento valori di default in eeprom)
;Imposta tempi, andamento effetti con "presepe 4 fasi"
;Si accede a questo menu solo premendo il pulsante per 2 secondi dopo il reset
; Input:  TBL_EEDEFAULT         Tabella rom
; Output: Eeprom (0..127)       Locazioni eeprom utente
; Usate:  Count1

menu0   call    led_begin_menu

        clrf    Count1          ;Azzera contatore
m0_1	movlw	0x07  		;Tabella in pagina 7
	movwf	PCLATH
	movf    Count1,w
	call	TBL_EEDEFAULT	;Preleva il valore dalla tabella

        BANK1
        movwf	EEDATA          ;Dato da scrivere su eeprom
        BANK0
        movf    Count1,w
        BANK1
        movwf   EEADR           ;Indirizzo eeprom
;       BANK0
        call    write_eeprom

        incf    Count1,f        ;Prossima locazione (0..127)
        movf    Count1,w
        xorlw   MAXEEA          ;Confronta con il massimo
        btfss   STATUS,Z
        goto    m0_1

        call    del_1s          ;Attesa 1 secondo
        call    led_end_menu
        return

;-----------------------------------------------------
;Gestione Menu 1..8 (Impostazione tempi per ciascuna delle 8 fasi)
;Legge il valore da EEprom (locazioni 0..7, valore 0..63), lo visualizza in binario
;sui 10 led delle uscite e ne permette la modifica (su incremento)
;da parte dell'utente premendo il pulsante PMenu.
;Infine, quando l'utente non preme il pulsante per pi di 5s,
;salva il valore su EEprom nella stessa locazione di partenza ed esce.

;Esempi di segnalazione valori sui 10 led delle uscite (1=on, 0=off, -=non usato)
;I led 3,4,5 rappresentano i 3 bit MSB, mentre i led 8,9,10 i 3 bit LSB
; Value=0       Led=--000--000          minimo
; Value=3       Led=--000--011
; Value=12      Led=--001--100
; Value=30      Led=--011--110
; Value=63      Led=--111--111          massimo

; Input:  Menu
; Output: O_OUT1...10
; Input:  I_PMENU
; Output: EEprom (0..3)
; Usate:  Value

menu1__8
        decf    Menu,w          ;Calcola l'indirizzo EEprom per valore tempo
        call    read_eeprom     ;Ritorna in w il valore della EEprom
        andlw   B'00111111'     ;e lo maschera con i 6 bit LSB (limita a 0..63)
        movwf   Value


m18_1   call    out_irq_off     ;Genera segnalazione 0..63 in binario sui led
        btfsc   Value,5         ;bit5 --> Led3
        bsf     O_OUT3
        btfsc   Value,4         ;bit4 --> Led4
        bsf     O_OUT4
        btfsc   Value,3         ;bit3 --> Led5
        bsf     O_OUT5
        btfsc   Value,2         ;bit2 --> Led8
        bsf     O_OUT8
        btfsc   Value,1         ;bit1 --> Led9
        bsf     O_OUT9
        btfsc   Value,0         ;bit0 --> Led10
        bsf     O_OUT10

        movlw   D'10'           ;Aspetta che l'utente preme il pulsante per
        movwf   CPMenuL         ;incrementare il valore (0..15)
m18_2   call    del_500ms       ;Si esce (e si salva) se non si preme per 5sec
        btfss   I_PMENU
        goto    m18_3
        decfsz  CPMenuL,f
        goto    m18_2
        goto    m18_4

m18_3   incf    Value,f         ;Pulsante premuto. Incrementa valore fino a 63
        btfsc   Value,6
        clrf    Value
        goto    m18_1

m18_4   decf    Menu,w          ;Salva Value su EEprom alla locazione Menu-1
        BANK1
        movwf   EEADR
        BANK0
        movf    Value,w
        BANK1
        movwf   EEDATA
;       BANK0
        call    write_eeprom
        return


;-----------------------------------------------------
;Gestione Menu 9 (Test funzionamento 10 uscite)
;Incremento e decremento luminosit in sequenza sulle 10 uscite
;Il ciclo viene eseguito 2 volte, dopodich si ritorna al ciclo normale
; Output: Light+0x00 ... Light+0x0A
; Usate:  Count1

menu9   clrf    Light+0x00      ;Inizializza luminosit uscite a 0
        clrf    Light+0x01
        clrf    Light+0x02
        clrf    Light+0x03
        clrf    Light+0x04
        clrf    Light+0x05
        clrf    Light+0x06
        clrf    Light+0x07
        clrf    Light+0x08
        clrf    Light+0x09

        movlw   0x02            ;Contatore 2 cicli di test funzionamento
        movwf   Count1
        bsf     INTCON,GIE      ;Abilita interrupt
m9_1    movlw   Light+0x00      ;Imposta il puntatore sulla 1^ variabile
        movwf   FSR             ;che regola la luminosit

m9_2    incf    INDF,f          ;Incrementa luminosit fino a 255 (max)
        call    deli_10ms       ;Tempo = 10ms * 255 = 2.5s
        movf    INDF,w
        xorlw   D'255'
        btfss   STATUS,Z
        goto    m9_2

m9_3    decf    INDF,f          ;Decrementa luminosit fino a 0 (min)
        call    deli_10ms       ;Tempo = 10ms * 255 = 2.5s
        movf    INDF,w
        btfss   STATUS,Z
        goto    m9_3

        incf    FSR,f           ;Incrementa puntatore e verifica se massimo
        movf    FSR,w
        xorlw   Light+0x0A
        btfss   STATUS,Z
        goto    m9_2            ;Procede con prossima variabile uscita

        decfsz  Count1,f        ;Ripete il ciclo per la seconda volta
        goto    m9_1

        call    out_irq_off     ;Disattiva irq e pone uscite a 0
        return                  ;Esce


;-----------------------------------------------------
;Genera la segnalazione sul led Time per Inizio e Fine menu
; - Inizio: Attesa 1 secondo - lampeggio 2 volte - Attesa 1 secondo
; - Fine:   Attesa 1 secondo - lampeggio 5 volte - Attesa 1 secondo

; Output: O_LTIME
; Usate:  Count1

led_begin_menu                  ;Segnalazione inizio menu
        movlw   D'2'
        goto    lbem_1

led_end_menu                    ;Segnalazione fine menu
        movlw   D'5'
lbem_1  movwf   Count1

        bcf     O_LTIME
        call    del_1s          ;Attesa 1 secondo
lbem_2  bsf     O_LTIME         ;Led Time acceso per 100ms
        call    del_100ms
        bcf     O_LTIME         ;Led Time spento per 100ms
        call    del_100ms
        decfsz  Count1,f
        goto    lbem_2
        call    del_1s          ;Attesa 1 secondo
        return

