	ORG	700H            ;Tabelle in pagina 7

;-----------------------------------------------------
;Tabella per caricare in T10msH,L il tempo del singolo passo (per ciascuna fase),
;scelto da utente mediante il valore 0..63 prelevato da Eeprom
TBL_TIMESTEP
	addwf	PCL,f

;       Valore T10msH,L         Settaggio       Tempo fase (secondi) =
;       esadecimale             utente EEprom   T10msH,L * 512 * 0.01

        retlw   0x00            ;1              10s
        retlw   0x02
        retlw   0x00            ;2              20s
        retlw   0x04
        retlw   0x00            ;3              30s
        retlw   0x06
        retlw   0x00            ;4              40s
        retlw   0x08
        retlw   0x00            ;5              50s
        retlw   0x0A
        retlw   0x00            ;6              1min
        retlw   0x0C
        retlw   0x00            ;7              1min 15s
        retlw   0x0E
        retlw   0x00            ;8              1min 30s
        retlw   0x11
        retlw   0x00            ;9              1min 45s
        retlw   0x14
        retlw   0x00            ;10             2min
        retlw   0x17

        retlw   0x00            ;11             2min 30s
        retlw   0x1D
        retlw   0x00            ;12             3min
        retlw   0x23
        retlw   0x00            ;13             3min 30s
        retlw   0x29
        retlw   0x00            ;14             4min
        retlw   0x2F
        retlw   0x00            ;15             5min
        retlw   0x3A
        retlw   0x00            ;16             6min
        retlw   0x46
        retlw   0x00            ;17             7min
        retlw   0x52
        retlw   0x00            ;18             8min
        retlw   0x5D
        retlw   0x00            ;19             9min
        retlw   0x69
        retlw   0x00            ;20             10min
        retlw   0x75

        retlw   0x00            ;21             12min
        retlw   0x8C
        retlw   0x00            ;22             15min
        retlw   0xAF
        retlw   0x00            ;23             20min
        retlw   0xEA
        retlw   0x01            ;24             25min
        retlw   0x25
        retlw   0x01            ;25             30min
        retlw   0x5F
        retlw   0x01            ;26             35min
        retlw   0x9A
        retlw   0x01            ;27             40min
        retlw   0xD4
        retlw   0x02            ;28             45min
        retlw   0x0F
        retlw   0x02            ;29             50min
        retlw   0x49
        retlw   0x02            ;30             55min
        retlw   0x84

        retlw   0x02            ;31             1h
        retlw   0xBF
        retlw   0x03            ;32             1h 10min
        retlw   0x34
        retlw   0x03            ;33             1h 20min
        retlw   0xA9
        retlw   0x04            ;34             1h 30min
        retlw   0x1E
        retlw   0x04            ;35             1h 40min
        retlw   0x93
        retlw   0x05            ;36             1h 50min
        retlw   0x09
        retlw   0x05            ;37             2h
        retlw   0x7E
        retlw   0x06            ;38             2h 15min
        retlw   0x2E
        retlw   0x06            ;39             2h 30min
        retlw   0xDD
        retlw   0x07            ;40             2h 45min
        retlw   0x8D

        retlw   0x08            ;41             3h
        retlw   0x3D
        retlw   0x08            ;42             3h 15min
        retlw   0xED
        retlw   0x09            ;43             3h 30min
        retlw   0x9C
        retlw   0x0A            ;44             3h 45min
        retlw   0x4C
        retlw   0x0A            ;45             4h
        retlw   0xFC
        retlw   0x0B            ;46             4h 15min
        retlw   0xAC
        retlw   0x0C            ;47             4h 30min
        retlw   0x5C
        retlw   0x0D            ;48             4h 45min
        retlw   0x0B
        retlw   0x0D            ;49             5h
        retlw   0xBB

        retlw   0x0F            ;50             5h 30min
        retlw   0x1B
        retlw   0x10            ;51             6h
        retlw   0x7A
        retlw   0x11            ;52             6h 30min
        retlw   0xDA
        retlw   0x13            ;53             7h
        retlw   0x39
        retlw   0x14            ;54             7h 30min
        retlw   0x99
        retlw   0x15            ;55             8h
        retlw   0xF9
        retlw   0x17            ;56             8h 30min
        retlw   0x58
        retlw   0x18            ;57             9h
        retlw   0xB8
        retlw   0x1A            ;58             9h 30min
        retlw   0x17
        retlw   0x1B            ;59             10h
        retlw   0x77
        retlw   0x1C            ;60             10h 30min
        retlw   0xD6

        retlw   0x1E            ;61             11h
        retlw   0x36
        retlw   0x1F            ;62             11h 30min
        retlw   0x96
        retlw   0x20            ;63             12h
        retlw   0xF5



;-----------------------------------------------------
;Tabella per caricamento valori default in EEprom (Presepe 4 fasi)
TBL_EEDEFAULT
	addwf	PCL,f

        retlw   0x02            ;Tempo fasi 1..8
        retlw   0x03
        retlw   0x02
        retlw   0x03
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0xBF            ;Andamenti Uscita OUT1 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0xAA            ;Andamenti Uscita OUT2 fasi 1..8
        retlw   0x77
        retlw   0xEE
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Andamenti Uscita OUT3 fasi 1..8
        retlw   0x00
        retlw   0xBF
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0xEE            ;Andamenti Uscita OUT4 fasi 1..8
        retlw   0x00
        retlw   0xAA
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0xEE            ;Andamenti Uscita OUT5 fasi 1..8
        retlw   0x00
        retlw   0xAA
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x40            ;Andamenti Uscita OUT6 fasi 1..8
        retlw   0x00
        retlw   0x01
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x60            ;Andamenti Uscita OUT7 fasi 1..8
        retlw   0x00
        retlw   0x03
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x70            ;Andamenti Uscita OUT8 fasi 1..8
        retlw   0x00
        retlw   0x07
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x74            ;Andamenti Uscita OUT9 fasi 1..8
        retlw   0x00
        retlw   0x17
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Andamenti Uscita OUT10 fasi 1..8
        retlw   0x77
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT1 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT2 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT3 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT4 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x30            ;Modalit Random e Tremolo Uscita OUT5 fasi 1..8
        retlw   0x33
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT6 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT7 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT8 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT9 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00

        retlw   0x00            ;Modalit Random e Tremolo Uscita OUT10 fasi 1..8
        retlw   0x00
        retlw   0x00
        retlw   0x00
